local beql, self = beql, beql

local L = AceLibrary("AceLocale-2.2"):new("beql")

local AWFW = 220
-- Addon functions

function beql:InitAchievementTracker()
	beql.AchievmentFrameTracker = CreateFrame("Frame","AchievmentFrameTracker", UIParent)
	beql.AchievmentFrameTracker:SetFrameStrata("BACKGROUND")
	beql.AchievmentFrameTracker:SetWidth(200)
	beql.AchievmentFrameTracker:SetHeight(100)
	beql.AchievmentFrameTracker:SetPoint("CENTER",0,0)
	beql.AchievmentFrameTracker:SetBackdrop({
--		bgFile="Interface\\Tooltips\\UI-Tooltip-Background",
		edgeFile="Interface\\Tooltips\\UI-Tooltip-Border", tile = true, edgeSize = 16, tileSize = 16,
		insets = { left= 5, right = 5, top = 5, bottom = 5 }
		})			
	beql.AchievmentFrameTracker:Show()
	beql.AchievmentFrameTracker:RegisterForDrag("LeftButton");
	beql.AchievmentFrameTracker:SetMovable(true)
	beql.AchievmentFrameTracker:EnableMouse(true)
	beql.AchievmentFrameTracker:SetScript("OnDragStart",
        function() 
          beql.AchievmentFrameTracker.ismoving = true 
          beql.AchievmentFrameTracker:StartMoving() 
        end)
	beql.AchievmentFrameTracker:SetScript("OnDragStop",
        function() 
          beql.AchievmentFrameTracker.ismoving = false 
          beql.AchievmentFrameTracker:StopMovingOrSizing() 
          --beql:SavePositionTracker() 
        end)

	beql.AchievmentFrameTrackerTitle = CreateFrame("Frame","AchievmentFrameTrackerTitle", AchievmentFrameTracker)
	beql.AchievmentFrameTrackerTitle:ClearAllPoints()
	beql.AchievmentFrameTrackerTitle:SetHeight(32)
	beql.AchievmentFrameTrackerTitle:SetPoint("TOPLEFT",AchievmentFrameTracker, "TOPLEFT",0,0)
	beql.AchievmentFrameTrackerTitle:SetPoint("TOPRIGHT",AchievmentFrameTracker, "TOPRIGHT",0,0)
	beql.AchievmentFrameTrackerTitle:SetBackdrop({
--		bgFile="Interface\\Tooltips\\UI-Tooltip-Background",
		edgeFile="Interface\\Tooltips\\UI-Tooltip-Border", tile = true, edgeSize = 16, tileSize = 16,
		insets = { left= 5, right = 5, top = 5, bottom = 5 }
		})			
	beql.AchievmentFrameTrackerTitle:SetFrameStrata("BACKGROUND")
	beql.AchievmentFrameTrackerTitle:SetFrameLevel("1")
	beql.AchievmentFrameTrackerTitle:SetAlpha(50)
	beql.AchievmentFrameTrackerTitle:SetMovable(true)
	beql.AchievmentFrameTrackerTitle:EnableMouse(true)
	beql.AchievmentFrameTrackerTitle:Show()

	
	beql.AchievmentFrameTrackerTitleText = beql.AchievmentFrameTrackerTitle:CreateFontString("AchievmentFrameTrackerTitleText","BACKGROUND","QuestWatchFontTemplate")
	beql.AchievmentFrameTrackerTitleText:SetPoint("LEFT",10,1)
	beql.AchievmentFrameTrackerTitleText:SetAlpha(1)
	beql.AchievmentFrameTrackerTitleText:SetText("Achievementtracker")


	beql.AchievmentFrameTrackerMinimizeButton = CreateFrame("Button","TrackerMinimizeButton", AchievmentFrameTrackerTitle, "UIPanelButtonTemplate")
	beql.AchievmentFrameTrackerMinimizeButton:SetNormalTexture("Interface\\AddOns\\beql\\Images\\minimize_up")
	beql.AchievmentFrameTrackerMinimizeButton:SetPushedTexture("Interface\\AddOns\\beql\\Images\\minimize_down")
	beql.AchievmentFrameTrackerMinimizeButton:SetHighlightTexture("Interface\\Buttons\\UI-Panel-MinimizeButton-Highlight")
	beql.AchievmentFrameTrackerMinimizeButton:SetWidth(18)
	beql.AchievmentFrameTrackerMinimizeButton:SetHeight(18)
	beql.AchievmentFrameTrackerMinimizeButton:Show()
	beql.AchievmentFrameTrackerMinimizeButton:ClearAllPoints()
	beql.AchievmentFrameTrackerMinimizeButton:SetPoint("TOPRIGHT",AchievmentFrameTrackerTitle, "TOPRIGHT", -4,2)

	beql.AchievmentFrameTrackerMinimizeButton:SetScript("OnClick", function() 
		beql:ToggleTracker()  
	end)

	beql:CreateOptionsAchiev()
end

function beql:CreateOptionsAchiev()
	optionsmain.args.general.args.EnableATracker = {
					type = 'toggle',
					order = 5,
					width = 'full',
					name = "Enable Achievementtracker",
					desc = L["Make the Tracker movable even with CTMod loaded. Please check your CTMod config before using it"],
					get = function(info) return beql.db.profile.ATrackerEnable end,
					set = function(info, newval)
						self.db.profile.ATrackerEnable = newval
						if newval then
							beql:InitAchievementTracker()
						end
					end,
		}


end


function beql:ToggleTracker ()
	if beql.db.profile.ATrackerToggled then 
		beql.AchievmentFrameTracker:SetHeight(100)
		AchievementWatchFrame:Show()
		beql.db.profile.ATrackerToggled = false
	else
		beql.AchievmentFrameTracker:SetHeight(32)
		AchievementWatchFrame:Hide()
		beql.db.profile.ATrackerToggled = true
	end
	
	AchievementWatchFrame:SetParent("AchievmentFrameTracker")
	--AchievementWatchFrame:ClearAllPoints()
	--AchievementWatchFrame:SetPoint("TOPLEFT",AchievmentFrameTracker, "TOPLEFT", 0,-32)
	AchievementWatchFrame:SetMovable(true)
	AchievementWatchFrame:EnableMouse(true)
	AchievementWatchFrame:SetScript("OnDragStart",
        function() 
          beql.AchievmentFrameTracker.ismoving = true 
          beql.AchievmentFrameTracker:StartMoving() 
        end)
	AchievementWatchFrame:SetScript("OnDragStop",
        function() 
          beql.AchievmentFrameTracker.ismoving = false 
          beql.AchievmentFrameTracker:StopMovingOrSizing() 
          --beql:SavePositionTracker() 
        end)
	
end

function beql:AchievementFrameManagePosition()
	if not AchievementWatchFrame:IsShown() then
		-- Frame not shown, do nothing
		return
	end
	AWFW = AchievementWatchFrame.desiredWidth
	AchievementWatchFrame:ClearAllPoints()
	if beql.db.profile.ATrackerEnable and beql.AchievmentFrameTracker then
		AchievementWatchFrame:SetPoint("TOPLEFT", "AchievmentFrameTracker", "TOPLEFT", 13, -32)
		beql.AchievmentFrameTracker:SetWidth(AWFW + 26)
		beql.AchievmentFrameTracker:SetHeight(AchievementWatchFrame:GetHeight() + 58)
		AchievementWatchFrame:SetBackdrop({	bgFile="Interface\\Tooltips\\UI-Tooltip-Background",})
	else
		AchievementWatchFrame:SetPoint("TOPRIGHT", "MinimapCluster", "BOTTOMRIGHT", -93, -13)
	end
	if AWFW then
		AchievementWatchFrame:SetWidth(AWFW);
	end
	
		
	
end		



function beql:printpoints()
	for i = 0, QuestWatchFrame:GetNumPoints() do
		point, relativeTo, relativePoint, xOfs, yOfs = AchievementWatchFrame:GetPoint(i)
		DEFAULT_CHAT_FRAME:AddMessage(point)
		DEFAULT_CHAT_FRAME:AddMessage(relativeTo:GetName())
		DEFAULT_CHAT_FRAME:AddMessage(relativePoint)
		DEFAULT_CHAT_FRAME:AddMessage(xOfs)
		DEFAULT_CHAT_FRAME:AddMessage(yOfs)
	end
	
end

function beql:printlines()
	print("---- Lines ----")
	for i = 1, 20 do
		line = getglobal("AchievementWatchLine" .. i)
		if line and line:IsShown() then 
			print("- Line " .. i ..": " .. line:GetWidth())
			--print(line:GetText())
		end
		line = getglobal("AchievementWatchLine" .. i .. "Button")
		if line and line:IsShown() then 
			print("- Button " .. i ..": " .. line:GetWidth())
			--print(line:GetText())
		end
		line = getglobal("AchievementWatchLine" .. i .. "StatusBar")
		if line and line:IsShown() then 
			print("- StatusBar " .. i ..": " .. line:GetWidth())
			--print(line:GetText())
		end
	end
end

--- EOF ---